.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib

S macro	szText:VARARG 
	LOCAL Buff
.data
	Buff db szText, 0h
.code
	exitm <OFFSET Buff>
endm

.CONST
	DL_BEGINDRAG	equ WM_USER+133
	DL_DRAGGING	equ WM_USER+134
	DL_DROPPED	equ WM_USER+135
	IDD_DLG1	equ 1000
	IDC_LST1	equ 1001
.DATA
	icc	 	QWORD	03FFF00000008h
.DATA?
	hInstance	DD 	?
	DrgListMsg	DD	?
	hListbox	DD	?
.CODE
DlgProc proc uses edi hwnd,uMsg,wParam,lParam
	LOCAL pt	 :POINT
	LOCAL rect	 :RECT
	LOCAL buffer[256]:BYTE

	mov eax, uMsg 
	.if eax==WM_INITDIALOG
		invoke GetDlgItem, hwnd ,IDC_LST1
		mov  hListbox ,eax

		invoke MakeDragList,hListbox
		invoke RegisterWindowMessage,S("commctrl_DragListMsg")
		mov  DrgListMsg ,eax

		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 1")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 2")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 3")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 4")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 5")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 6")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 7")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 8")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 9")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 10")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 11")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 12")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 13")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 14")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 15")
		invoke SendMessage, hListbox ,LB_ADDSTRING,0,S("Item 16")

	.elseif eax==DrgListMsg
		mov edi, lParam 
		.if [edi][DRAGLISTINFO.uNotification] == DL_BEGINDRAG
			invoke LBItemFromPt,[edi][DRAGLISTINFO.hWnd],[edi][DRAGLISTINFO.ptCursor.x],\
				[edi][DRAGLISTINFO.ptCursor.y],FALSE
			push eax
			invoke DrawInsert, hwnd ,[edi][DRAGLISTINFO.hWnd],eax
			pop eax
			invoke SetWindowLong,[edi][DRAGLISTINFO.hWnd],GWL_USERDATA,eax
			invoke SetWindowLong, hwnd ,DWL_MSGRESULT,TRUE
			mov eax,TRUE
			ret

		.elseif [edi][DRAGLISTINFO.uNotification] == DL_DRAGGING
			invoke LBItemFromPt,[edi][DRAGLISTINFO.hWnd],[edi][DRAGLISTINFO.ptCursor.x],\
				[edi][DRAGLISTINFO.ptCursor.y],FALSE
			.if eax ==0
				; Check to see if the listbox needs scrolling
				invoke GetCursorPos,ADDR pt
				invoke GetWindowRect,[edi][DRAGLISTINFO.hWnd],ADDR rect
				mov eax, pt.y 
				.if eax <= rect.top 
					invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_GETTOPINDEX,0,0
					.if eax !=0
						dec eax
						invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_SETTOPINDEX,eax,0
					.endif
				.elseif eax >= rect.bottom 
					invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_GETTOPINDEX,0,0
					inc eax
					invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_SETTOPINDEX,eax,0
				.endif
				invoke SetWindowLong, hwnd ,DWL_MSGRESULT, DL_STOPCURSOR
				mov eax,TRUE
				ret
			.endif
			invoke DrawInsert, hwnd ,[edi][DRAGLISTINFO.hWnd],eax
			invoke SetWindowLong, hwnd ,DWL_MSGRESULT,DL_MOVECURSOR

		.elseif [edi][DRAGLISTINFO.uNotification] == DL_DROPPED
			invoke GetWindowLong,[edi][DRAGLISTINFO.hWnd],GWL_USERDATA
			push eax
			mov ebx,eax
			invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_GETTEXT,ebx,ADDR buffer
			invoke LBItemFromPt,[edi][DRAGLISTINFO.hWnd],[edi][DRAGLISTINFO.ptCursor.x],\
				[edi][DRAGLISTINFO.ptCursor.y],FALSE
			.if eax ==0
				pop eax
				ret
			.endif
			mov ebx,eax
			invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_INSERTSTRING,ebx,ADDR buffer
			invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_SETCURSEL,ebx,0
			pop ecx
			.if  ecx >= eax
				inc ecx
			.endif
			invoke SendMessage,[edi][DRAGLISTINFO.hWnd],LB_DELETESTRING,ecx,0
			invoke DrawInsert, hwnd ,[edi][DRAGLISTINFO.hWnd],-1
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog, hwnd ,0
	.else
		mov EAX,FALSE
		ret
	.endif

	mov eax, TRUE
	ret
DlgProc endp
start:
	invoke GetModuleHandle, 0
	mov    hInstance ,eax
	invoke InitCommonControlsEx,OFFSET icc
	invoke DialogBoxParam, hInstance ,IDD_DLG1,0,ADDR DlgProc,0
	invoke ExitProcess,0

end start
